<template>
    <div class="container">
        <div class="row">
            <div class="col-sm">
                <h3>Total de gastos {{totalGastos | toCurrency}}</h3>
                <h3>Total de gastos con impuestos {{totalGastosImpuestos | toCurrency}}</h3>
            </div>
        </div>
        <div class="row">
            <div class="col-sm">
                <h4>Totales por departamento (Sin impuestos)</h4>
                <VueApexCharts ref="chart1" width="500" type="bar" :options="options" :series="series"></VueApexCharts>
            </div>
            <div class="col-sm">
                <h4>Porcentaje gastos por departamento (Sin impuestos)</h4>
                <VueApexCharts ref="chart2" width="500" type="pie" :options="options2"
                               :series="series2"></VueApexCharts>
            </div>
            <div class="col-sm">
                <h4>Gastos reportados (Sin impuestos)</h4>
                <VueApexCharts ref="chart3" width="500" type="bar" :options="options3"
                               :series="series3"></VueApexCharts>
            </div>
        </div>
    </div>
</template>

<script>
    import VueApexCharts from 'vue-apexcharts'

    export default {
        name: "GraficasComponent",
        components: {
            VueApexCharts
        },
        data: () => ({
            totalGastos: 0,
            totalGastosImpuestos: 0,
            options: {
                chart: {
                    id: 'vuechart-example'
                },
                plotOptions: {
                    bar: {
                        horizontal: true,
                    }
                },
                xaxis: {
                    categories: [1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998]
                }
            },
            series: [{
                data: []
            }],
            options2: {
                labels: []
            },
            series2: [],
            series3: [],
            options3: {
                chart: {
                    id: 'vuechart-example'
                },
                plotOptions: {
                    bar: {
                        horizontal: true,
                    }
                },
                xaxis: {
                    categories: [1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998]
                }
            },
        }),
        methods: {
            getExpenseByDepartment() {
                window.axios.get('/api/getExpenseByDepartment').then((response) => {
                    this.totalGastos = response.data.expenses.reduce(function (total, currentValue) {
                        return total + (currentValue.TotalExpense / 100)
                    }, 0);

                    this.totalGastosImpuestos = response.data.expenses.reduce(function (total, currentValue) {
                        return total + currentValue.expenses.reduce(function (tot, cv) {
                            return tot + (cv.amount / 100) * ((cv.tax_percentage / 100) + 1)
                        }, 0)
                    }, 0);

                    const departments = response.data.expenses.map(e => e.name)
                    const totalDepartments = response.data.expenses.map(a => a.TotalExpense / 100)
                    const totalExpenses = response.data.expenses.map(a => a.expenses.length)
                    this.$refs.chart1.updateOptions({
                        xaxis: {
                            categories: departments
                        }
                    })
                    this.$refs.chart3.updateOptions({
                        xaxis: {
                            categories: departments
                        }
                    })
                    this.$refs.chart1.updateSeries([{
                        data: totalDepartments
                    }]);
                    this.$refs.chart3.updateSeries([{
                        data: totalExpenses
                    }]);

                    this.$refs.chart2.updateOptions({
                        labels: departments
                    })
                    this.$refs.chart2.updateSeries(totalDepartments);
                })
            }
        },
        mounted() {
            this.getExpenseByDepartment()
        }
    }
</script>

<style scoped>

</style>
